package com.hfkj.dao;

import com.hfkj.entity.BsUserStudentRel;
import com.hfkj.entity.BsUserStudentRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsUserStudentRelMapper extends BsUserStudentRelMapperExt {
    @SelectProvider(type=BsUserStudentRelSqlProvider.class, method="countByExample")
    long countByExample(BsUserStudentRelExample example);

    @DeleteProvider(type=BsUserStudentRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsUserStudentRelExample example);

    @Delete({
        "delete from bs_user_student_rel",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into bs_user_student_rel (user_id, student_id, ",
        "relationship, create_time, ",
        "update_time, `status`, ",
        "ext_1, ext_2, ext_3)",
        "values (#{userId,jdbcType=BIGINT}, #{studentId,jdbcType=BIGINT}, ",
        "#{relationship,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsUserStudentRel record);

    @InsertProvider(type=BsUserStudentRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsUserStudentRel record);

    @SelectProvider(type=BsUserStudentRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="student_id", property="studentId", jdbcType=JdbcType.BIGINT),
        @Result(column="relationship", property="relationship", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsUserStudentRel> selectByExample(BsUserStudentRelExample example);

    @Select({
        "select",
        "id, user_id, student_id, relationship, create_time, update_time, `status`, ext_1, ",
        "ext_2, ext_3",
        "from bs_user_student_rel",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="student_id", property="studentId", jdbcType=JdbcType.BIGINT),
        @Result(column="relationship", property="relationship", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsUserStudentRel selectByPrimaryKey(Integer id);

    @UpdateProvider(type=BsUserStudentRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsUserStudentRel record, @Param("example") BsUserStudentRelExample example);

    @UpdateProvider(type=BsUserStudentRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsUserStudentRel record, @Param("example") BsUserStudentRelExample example);

    @UpdateProvider(type=BsUserStudentRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsUserStudentRel record);

    @Update({
        "update bs_user_student_rel",
        "set user_id = #{userId,jdbcType=BIGINT},",
          "student_id = #{studentId,jdbcType=BIGINT},",
          "relationship = #{relationship,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(BsUserStudentRel record);
}