package com.hfkj.dao;

import com.hfkj.entity.EnOilDepots;
import com.hfkj.entity.EnOilDepotsExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EnOilDepotsMapper extends EnOilDepotsMapperExt {
    @SelectProvider(type=EnOilDepotsSqlProvider.class, method="countByExample")
    long countByExample(EnOilDepotsExample example);

    @DeleteProvider(type=EnOilDepotsSqlProvider.class, method="deleteByExample")
    int deleteByExample(EnOilDepotsExample example);

    @Delete({
        "delete from en_oil_depots",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into en_oil_depots (item_id, oil_depot_no, ",
        "oil_depot_name, latitude, ",
        "longitude, contact_person, ",
        "contact_info, capacity, ",
        "current_stock, warning_level, ",
        "`status`, create_user, ",
        "create_user_name, create_time, ",
        "update_user, update_user_name, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{itemId,jdbcType=BIGINT}, #{oilDepotNo,jdbcType=VARCHAR}, ",
        "#{oilDepotName,jdbcType=VARCHAR}, #{latitude,jdbcType=DECIMAL}, ",
        "#{longitude,jdbcType=DECIMAL}, #{contactPerson,jdbcType=VARCHAR}, ",
        "#{contactInfo,jdbcType=VARCHAR}, #{capacity,jdbcType=DECIMAL}, ",
        "#{currentStock,jdbcType=DECIMAL}, #{warningLevel,jdbcType=DECIMAL}, ",
        "#{status,jdbcType=INTEGER}, #{createUser,jdbcType=BIGINT}, ",
        "#{createUserName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateUser,jdbcType=BIGINT}, #{updateUserName,jdbcType=VARCHAR}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EnOilDepots record);

    @InsertProvider(type=EnOilDepotsSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EnOilDepots record);

    @SelectProvider(type=EnOilDepotsSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="item_id", property="itemId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_depot_no", property="oilDepotNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_depot_name", property="oilDepotName", jdbcType=JdbcType.VARCHAR),
        @Result(column="latitude", property="latitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="longitude", property="longitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="contact_person", property="contactPerson", jdbcType=JdbcType.VARCHAR),
        @Result(column="contact_info", property="contactInfo", jdbcType=JdbcType.VARCHAR),
        @Result(column="capacity", property="capacity", jdbcType=JdbcType.DECIMAL),
        @Result(column="current_stock", property="currentStock", jdbcType=JdbcType.DECIMAL),
        @Result(column="warning_level", property="warningLevel", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EnOilDepots> selectByExample(EnOilDepotsExample example);

    @Select({
        "select",
        "id, item_id, oil_depot_no, oil_depot_name, latitude, longitude, contact_person, ",
        "contact_info, capacity, current_stock, warning_level, `status`, create_user, ",
        "create_user_name, create_time, update_user, update_user_name, update_time, ext_1, ",
        "ext_2, ext_3",
        "from en_oil_depots",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="item_id", property="itemId", jdbcType=JdbcType.BIGINT),
        @Result(column="oil_depot_no", property="oilDepotNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="oil_depot_name", property="oilDepotName", jdbcType=JdbcType.VARCHAR),
        @Result(column="latitude", property="latitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="longitude", property="longitude", jdbcType=JdbcType.DECIMAL),
        @Result(column="contact_person", property="contactPerson", jdbcType=JdbcType.VARCHAR),
        @Result(column="contact_info", property="contactInfo", jdbcType=JdbcType.VARCHAR),
        @Result(column="capacity", property="capacity", jdbcType=JdbcType.DECIMAL),
        @Result(column="current_stock", property="currentStock", jdbcType=JdbcType.DECIMAL),
        @Result(column="warning_level", property="warningLevel", jdbcType=JdbcType.DECIMAL),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EnOilDepots selectByPrimaryKey(Long id);

    @UpdateProvider(type=EnOilDepotsSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EnOilDepots record, @Param("example") EnOilDepotsExample example);

    @UpdateProvider(type=EnOilDepotsSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EnOilDepots record, @Param("example") EnOilDepotsExample example);

    @UpdateProvider(type=EnOilDepotsSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EnOilDepots record);

    @Update({
        "update en_oil_depots",
        "set item_id = #{itemId,jdbcType=BIGINT},",
          "oil_depot_no = #{oilDepotNo,jdbcType=VARCHAR},",
          "oil_depot_name = #{oilDepotName,jdbcType=VARCHAR},",
          "latitude = #{latitude,jdbcType=DECIMAL},",
          "longitude = #{longitude,jdbcType=DECIMAL},",
          "contact_person = #{contactPerson,jdbcType=VARCHAR},",
          "contact_info = #{contactInfo,jdbcType=VARCHAR},",
          "capacity = #{capacity,jdbcType=DECIMAL},",
          "current_stock = #{currentStock,jdbcType=DECIMAL},",
          "warning_level = #{warningLevel,jdbcType=DECIMAL},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_user = #{createUser,jdbcType=BIGINT},",
          "create_user_name = #{createUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_user = #{updateUser,jdbcType=BIGINT},",
          "update_user_name = #{updateUserName,jdbcType=VARCHAR},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(EnOilDepots record);
}